# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft and contributors.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class PolicyDefinition(Model):
    """
    The policy definition.

    :param policy_type: Gets or sets policy definition policy type. Possible
     values include: 'NotSpecified', 'BuiltIn', 'Custom'
    :type policy_type: str or :class:`policyType
     <azure.mgmt.resource.policy.models.policyType>`
    :param display_name: Gets or sets the policy definition display name.
    :type display_name: str
    :param description: Gets or sets the policy definition description.
    :type description: str
    :param policy_rule: Gets or sets the policy rule.
    :type policy_rule: object
    :param id: Gets or sets the Id of the policy definition.
    :type id: str
    :param name: Gets or sets the name of the policy definition.
    :type name: str
    """ 

    _attribute_map = {
        'policy_type': {'key': 'properties.policyType', 'type': 'str'},
        'display_name': {'key': 'properties.displayName', 'type': 'str'},
        'description': {'key': 'properties.description', 'type': 'str'},
        'policy_rule': {'key': 'properties.policyRule', 'type': 'object'},
        'id': {'key': 'id', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
    }

    def __init__(self, policy_type=None, display_name=None, description=None, policy_rule=None, id=None, name=None):
        self.policy_type = policy_type
        self.display_name = display_name
        self.description = description
        self.policy_rule = policy_rule
        self.id = id
        self.name = name
